/***************************************************************************
 *  Original Diku Mud copyright (C) 1990, 1991 by Sebastian Hammer,        *
 *  Michael Seifert, Hans Henrik St{rfeldt, Tom Madsen, and Katja Nyboe.   *
 *                                                                         *
 *  Merc Diku Mud improvments copyright (C) 1992, 1993 by Michael          *
 *  Chastain, Michael Quan, and Mitchell Tse.                              *
 *                                                                         *
 *  In order to use any part of this Merc Diku Mud, you must comply with   *
 *  both the original Diku license in 'license.doc' as well the Merc       *
 *  license in 'license.txt'.  In particular, you may not remove either of *
 *  these copyright notices.                                               *
 *                                                                         *
 *  Much time and thought has gone into this software and you are          *
 *  benefitting.  We hope that you share your changes too.  What goes      *
 *  around, comes around.                                                  *
 *                                                                         *
 *    And Rip's Mods (c) 1994 by Robert L. Peckham....                     *
 ***************************************************************************/

#if defined(macintosh)
#include <types.h>
#else
#include <sys/types.h>
#endif
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include "merc.h"



/*
 * The following special functions are available for rooms.
 */
DECLARE_ROOM_SPECIAL(	spec_start_room		);


ROOM_SPECIAL *room_fun_lookup( const char *name )
{
    if ( !str_cmp( name, "spec_start_room"       ) ) return spec_start_room;
    return 0;
}


bool spec_start_room( CHAR_DATA *ch, char *command, DO_FUN *fnptr,
  char *argument, ROOM_INDEX_DATA *room )
{
    if (IS_NPC(ch))
	return FALSE;

    if ( !str_cmp( command, "city" ) )
    {
	if ( !str_cmp( argument, "ys" ) )
	{
	    send_to_char("You have chosen the city of Ys.\n\r", ch );
	    char_from_room( ch );
	    char_to_room( ch, get_room_index( ROOM_VNUM_TEMPLE ), FALSE );
	    do_look( ch, "auto" );
	}
	else if ( !str_cmp( argument, "celemir" ) )
	{
	    send_to_char("You have chosen the city of Celemir.\n\r", ch );
	    char_from_room( ch );
	    char_to_room( ch, get_room_index( 20087 ), FALSE );
	    do_look( ch, "auto" );
	}
	else if ( !str_cmp( argument, "desert" ) )
	{
	    send_to_char("You have chosen the desert encampment.\n\r", ch );
	    char_from_room( ch );
	    char_to_room( ch, get_room_index( 1000 ), FALSE );
	    do_look( ch, "auto" );
	}
	else
	{
	    send_to_char("Usage:   city <city>\n\r", ch );
	    send_to_char("Where <city> is one of the following:\n\r", ch );
	    send_to_char("celemir\n\r", ch );
	    send_to_char("desert\n\r", ch );
	    send_to_char("ys\n\r", ch );
	    send_to_char("Celemir and desert are skeletal, feel free to write up descs.\n\r", ch );
	    send_to_char("Neat ones may be used.\n\r", ch );
	    send_to_char("Ys is more complete, but will be deleted eventually.\n\r", ch );
	}

	return TRUE;
    }

    return FALSE;
}

